diff --git a/drivers/scsi/qla2xxx/qla_init.c b/drivers/scsi/qla2xxx/qla_init.c
index 3f3417a3e891..3dc083bbac3c 100644
--- a/drivers/scsi/qla2xxx/qla_init.c
+++ b/drivers/scsi/qla2xxx/qla_init.c
@@ -19,8 +19,8 @@
 #include "qla_target.h"
 
 /*
-*  QLogic ISP2x00 Hardware Support Function Prototypes.
-*/
+ * QLogic ISP2x00 Hardware Support Function Prototypes.
+ */
 static int qla2x00_isp_firmware(scsi_qla_host_t *);
 static int qla2x00_setup_chip(scsi_qla_host_t *);
 static int qla2x00_fw_ready(scsi_qla_host_t *);
@@ -2381,15 +2381,15 @@ qla83xx_nic_core_fw_load(scsi_qla_host_t *vha)
 }
 
 /*
-* qla2x00_initialize_adapter
-*      Initialize board.
-*
-* Input:
-*      ha = adapter block pointer.
-*
-* Returns:
-*      0 = success
-*/
+ * qla2x00_initialize_adapter
+ *      Initialize board.
+ *
+ * Input:
+ *      ha = adapter block pointer.
+ *
+ * Returns:
+ *      0 = success
+ */
 int
 qla2x00_initialize_adapter(scsi_qla_host_t *vha)
 {
@@ -4661,18 +4661,18 @@ qla2x00_fw_ready(scsi_qla_host_t *vha)
 }
 
 /*
-*  qla2x00_configure_hba
-*      Setup adapter context.
-*
-* Input:
-*      ha = adapter state pointer.
-*
-* Returns:
-*      0 = success
-*
-* Context:
-*      Kernel context.
-*/
+ * qla2x00_configure_hba
+ *      Setup adapter context.
+ *
+ * Input:
+ *      ha = adapter state pointer.
+ *
+ * Returns:
+ *      0 = success
+ *
+ * Context:
+ *      Kernel context.
+ */
 static int
 qla2x00_configure_hba(scsi_qla_host_t *vha)
 {
@@ -4861,18 +4861,18 @@ static void qla2xxx_nvram_wwn_from_ofw(scsi_qla_host_t *vha, nvram_t *nv)
 }
 
 /*
-* NVRAM configuration for ISP 2xxx
-*
-* Input:
-*      ha                = adapter block pointer.
-*
-* Output:
-*      initialization control block in response_ring
-*      host adapters parameters in host adapter block
-*
-* Returns:
-*      0 = success.
-*/
+ * NVRAM configuration for ISP 2xxx
+ *
+ * Input:
+ *      ha = adapter block pointer.
+ *
+ * Output:
+ *      initialization control block in response_ring
+ *      host adapters parameters in host adapter block
+ *
+ * Returns:
+ *      0 = success.
+ */
 int
 qla2x00_nvram_config(scsi_qla_host_t *vha)
 {
@@ -5330,7 +5330,7 @@ static void qla_get_login_template(scsi_qla_host_t *vha)
  *      Updates Fibre Channel Device Database with what is actually on loop.
  *
  * Input:
- *      ha                = adapter block pointer.
+ *      ha = adapter block pointer.
  *
  * Returns:
  *      0 = success.
@@ -6599,7 +6599,7 @@ qla2x00_local_device_login(scsi_qla_host_t *vha, fc_port_t *fcport)
 }
 
 /*
- *  qla2x00_loop_resync
+ * qla2x00_loop_resync
  *      Resync with fibre channel devices.
  *
  * Input:
@@ -6657,12 +6657,12 @@ qla2x00_loop_resync(scsi_qla_host_t *vha)
 }
 
 /*
-* qla2x00_perform_loop_resync
-* Description: This function will set the appropriate flags and call
-*              qla2x00_loop_resync. If successful loop will be resynced
-* Arguments : scsi_qla_host_t pointer
-* returm    : Success or Failure
-*/
+ * qla2x00_perform_loop_resync
+ * Description: This function will set the appropriate flags and call
+ *              qla2x00_loop_resync. If successful loop will be resynced
+ * Arguments : scsi_qla_host_t pointer
+ * return    : Success or Failure
+ */
 
 int qla2x00_perform_loop_resync(scsi_qla_host_t *ha)
 {
@@ -7007,13 +7007,13 @@ qla2xxx_mctp_dump(scsi_qla_host_t *vha)
 }
 
 /*
-* qla2x00_quiesce_io
-* Description: This function will block the new I/Os
-*              Its not aborting any I/Os as context
-*              is not destroyed during quiescence
-* Arguments: scsi_qla_host_t
-* return   : void
-*/
+ * qla2x00_quiesce_io
+ * Description: This function will block the new I/Os
+ *              Its not aborting any I/Os as context
+ *              is not destroyed during quiescence
+ * Arguments: scsi_qla_host_t
+ * return   : void
+ */
 void
 qla2x00_quiesce_io(scsi_qla_host_t *vha)
 {
@@ -7175,15 +7175,15 @@ qla2x00_abort_isp_cleanup(scsi_qla_host_t *vha)
 }
 
 /*
-*  qla2x00_abort_isp
-*      Resets ISP and aborts all outstanding commands.
-*
-* Input:
-*      ha           = adapter block pointer.
-*
-* Returns:
-*      0 = success
-*/
+ * qla2x00_abort_isp
+ *      Resets ISP and aborts all outstanding commands.
+ *
+ * Input:
+ *      ha = adapter block pointer.
+ *
+ * Returns:
+ *      0 = success
+ */
 int
 qla2x00_abort_isp(scsi_qla_host_t *vha)
 {
@@ -7376,15 +7376,15 @@ qla2x00_abort_isp(scsi_qla_host_t *vha)
 }
 
 /*
-*  qla2x00_restart_isp
-*      restarts the ISP after a reset
-*
-* Input:
-*      ha = adapter block pointer.
-*
-* Returns:
-*      0 = success
-*/
+ * qla2x00_restart_isp
+ *      restarts the ISP after a reset
+ *
+ * Input:
+ *      ha = adapter block pointer.
+ *
+ * Returns:
+ *      0 = success
+ */
 static int
 qla2x00_restart_isp(scsi_qla_host_t *vha)
 {
@@ -7469,12 +7469,12 @@ qla25xx_init_queues(struct qla_hw_data *ha)
 }
 
 /*
-* qla2x00_reset_adapter
-*      Reset adapter.
-*
-* Input:
-*      ha = adapter block pointer.
-*/
+ * qla2x00_reset_adapter
+ *      Reset adapter.
+ *
+ * Input:
+ *      ha = adapter block pointer.
+ */
 int
 qla2x00_reset_adapter(scsi_qla_host_t *vha)
 {